

//Use the vector class extensively in the declaration and implementation
#include <vector>
#include <string>
#include <iostream>
using namespace std;


//****************************************************************************
// define an enumeration type for naming different categories of tokens
//****************************************************************************
typedef enum 
{
	KEYWORD,
	// keywords of BIOLA, like function, return, display, read, if, else, while 

	ID_NAME,	
	// identifiers, i.e. names of variables, labels, and functions

	ASSIGNMENT_OP,
	// =, the assignment operator		

	NUMERICAL_OP,
	// numerical operators	 (such as +, -, *, /, and %)	

	LOGICAL_OP,
	// numerical operators	 (such as !, ||, &&)	

	RELATIONAL_OP,
	// relational operators	 (such as >, ==, <, >=, <=, !=)
	
	NUMERICAL_LITERAL,	
	// numerical values (such as 2.45)	
	
	STRING_LITERAL,	
	// string literals (like "Hi Hi", in a pair of double quotes)

	COLON,
	// : to signal the end of function name and parameters declaration 

	SEMICOLON,			// ; to signal the end of statement 

	COMMA,				// a comma ,

	LEFT_PARENTHESIS,	// a left parenthesis (

	RIGHT_PARENTHESIS,	// a left parenthesis )

	LEFT_CURLYBRACE,	// a left curly brace {

	RIGHT_CURLYBRACE,	// a right curly brace }

	COMMENT	,	// The token // that starts a line of comments

	UNKNOWN,		// Something that we cannot recognize its category

} tokenCategory;



//****************************************************************************
// define a mnemonic name for the type to store tokens of one line of statement
//****************************************************************************
typedef vector<string> perLineTokenVector;


//****************************************************************************
// define a mnemonic name for the type to store tokens of lines of statement
//****************************************************************************
typedef vector<perLineTokenVector> vectOfTokenVects;


//****************************************************************************
// define a mnemonic name for the type to store categories of tokens 
// of one line of statement
//****************************************************************************
typedef vector<tokenCategory> perLineCategoryVector;


//****************************************************************************
// define a mnemonic name for the type to store categories of tokens 
// of one line of statement
//****************************************************************************
typedef vector<perLineCategoryVector> vectOfCategoryVects;




int main()
{
	//Write your code below



	return 0;
}
